#! /usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// Import necessary modules
var yargs_1 = __importDefault(require("yargs"));
var helpers_1 = require("yargs/helpers");
var buildService_1 = __importDefault(require("../services/buildService"));
var fileService_1 = __importDefault(require("../services/fileService"));
var ora_1 = __importDefault(require("ora"));
// Configure yargs to parse command line arguments
(0, yargs_1.default)((0, helpers_1.hideBin)(process.argv))
    .command('env', 'Show all available API-Lib environments of the project', function () { }, function (argv) {
    environmentsCommand();
})
    .command('init', 'Initialize the Project', function () { }, function (argv) {
    initCommand();
})
    .command('deploy <environment>', 'Deploy all routes in your project to the selected environment', function () { }, function (argv) {
    deployCommand(argv.environment);
})
    .demandCommand(1) // Require at least one command
    .strict() // Enforce strict mode
    .scriptName('apilib') // Set the script name for usage instructions
    .parse(); // Parse the arguments
// Define the 'environments' command function
function environmentsCommand() {
    // Implementation here
}
// Define the 'init' command function
function initCommand() {
    return __awaiter(this, void 0, void 0, function () {
        var startTime, spinner, _a, status, message, endTime, elapsedTime;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    console.info(" ");
                    console.info("==============================");
                    console.info(" ");
                    startTime = performance.now();
                    spinner = (0, ora_1.default)('Initializing API-Lib').start();
                    return [4 /*yield*/, fileService_1.default.generateConfigFile()];
                case 1:
                    _a = _b.sent(), status = _a[0], message = _a[1];
                    endTime = performance.now();
                    elapsedTime = endTime - startTime;
                    spinner.text = "".concat(message, " - ").concat(elapsedTime.toFixed(2), "ms");
                    status ? spinner.succeed() : spinner.fail();
                    console.info(" ");
                    console.info("==============================");
                    return [2 /*return*/];
            }
        });
    });
}
// Define the 'deploy' command function
function deployCommand(environment) {
    return __awaiter(this, void 0, void 0, function () {
        var startTime, spinner, _a, status, message, endTime, elapsedTime, operatorFolder;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    console.info(" ");
                    console.info("==============================");
                    console.info(" ");
                    startTime = performance.now();
                    spinner = (0, ora_1.default)('Loading config file').start();
                    return [4 /*yield*/, fileService_1.default.getConfigInfo()];
                case 1:
                    _a = _b.sent(), status = _a[0], message = _a[1];
                    endTime = performance.now();
                    elapsedTime = endTime - startTime;
                    if (!status || !message.projectid || !message.secretkey) {
                        spinner.text = "Error while reading config - ".concat(elapsedTime.toFixed(2), "ms");
                        spinner.fail();
                    }
                    else {
                        spinner.text = "Found apilib.config.json - ".concat(elapsedTime.toFixed(2), "ms");
                        spinner.succeed();
                    }
                    console.info(" ");
                    console.info("\u001B[34mDeploying to ".concat(environment));
                    return [4 /*yield*/, fileService_1.default.findOperatorFolder()];
                case 2:
                    operatorFolder = _b.sent();
                    console.info(" ");
                    console.info("Found operator folder: \u001B[33m".concat(operatorFolder, "\u001B[0m"));
                    console.info(" ");
                    return [4 /*yield*/, buildService_1.default.buildAllFilesInFolder(operatorFolder, environment, message.projectid, message.secretkey)];
                case 3:
                    _b.sent();
                    console.info("==============================");
                    return [2 /*return*/];
            }
        });
    });
}
