"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var esbuild = __importStar(require("esbuild"));
var ora_1 = __importDefault(require("ora"));
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var util_1 = require("util");
var uploadService_1 = __importDefault(require("./uploadService"));
var fileService_1 = __importDefault(require("./fileService"));
var uuid_1 = require("uuid");
// Convert fs.readdir and fs.stat to return promises
var readdir = (0, util_1.promisify)(fs_1.default.readdir);
var stat = (0, util_1.promisify)(fs_1.default.stat);
// Temporary storage for file data
var tempFileData = new Map();
var BuildService = /** @class */ (function () {
    function BuildService() {
    }
    // Singleton accessor for BuildService
    BuildService.getInstance = function () {
        if (!this._instance) {
            this._instance = new BuildService();
        }
        return this._instance;
    };
    // Method to build a single file
    BuildService.prototype.buildFile = function (file, filename, environment, projectid, secretkey) {
        return __awaiter(this, void 0, void 0, function () {
            var startTime, spinner, fileid, splitFilepath, operatorFolder, relativePath, splitFilename, method, endTime, elapsedTime;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        startTime = performance.now();
                        spinner = (0, ora_1.default)("Building ".concat(filename)).start();
                        fileid = (0, uuid_1.v4)();
                        splitFilepath = file.split('\\');
                        return [4 /*yield*/, fileService_1.default.findOperatorFolder()];
                    case 1:
                        operatorFolder = _a.sent();
                        operatorFolder.split('\\').forEach(function () { return splitFilepath.shift(); });
                        relativePath = splitFilepath.join('\\');
                        splitFilename = filename.split('.');
                        method = 'GET';
                        if (splitFilename.length === 3) {
                            switch (splitFilename[1]) {
                                case 'post':
                                    method = 'POST';
                                    break;
                                case 'put':
                                    method = 'PUT';
                                    break;
                                case 'delete':
                                    method = 'DELETE';
                                    break;
                                case 'patch':
                                    method = 'PATCH';
                                    break;
                            }
                            splitFilename.splice(1, 1); // Remove the method from the filename
                        }
                        // Remove the file extension
                        splitFilename.splice(1, 1);
                        // Modify the file path based on certain conditions
                        if (splitFilename[0] === 'index') {
                            splitFilepath.splice(splitFilepath.length - 1, 1);
                        }
                        if (!splitFilepath.includes(splitFilename[0])) {
                            splitFilepath.push(splitFilename[0]);
                        }
                        // Build the file using esbuild
                        return [4 /*yield*/, esbuild.build({
                                entryPoints: [file],
                                bundle: true,
                                minify: true,
                                platform: 'node',
                                target: 'node14',
                                format: 'esm',
                                external: ['apilib-npm', 'api-lib', 'node:fs', 'node:path', 'node:util', 'node:crypto'],
                                outfile: path_1.default.join(process.cwd(), "/.apilib/build/".concat(fileid, ".js")),
                            })];
                    case 2:
                        // Build the file using esbuild
                        _a.sent();
                        // Replace apilib-npm with actual path
                        return [4 /*yield*/, fileService_1.default.replaceContentInFile(path_1.default.join(process.cwd(), "/.apilib/build/".concat(fileid, ".js")), /api-lib/g, '../../src/apilib/index.ts')];
                    case 3:
                        // Replace apilib-npm with actual path
                        _a.sent();
                        endTime = performance.now();
                        elapsedTime = endTime - startTime;
                        spinner.text = "Built ".concat(filename, " - ").concat(elapsedTime.toFixed(2), "ms");
                        spinner.succeed();
                        // Upload the built file
                        return [4 /*yield*/, uploadService_1.default.uploadFileToFileserver(fileid, filename, splitFilepath, method, environment, projectid, secretkey)];
                    case 4:
                        // Upload the built file
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    // Method to build all files in a given folder
    BuildService.prototype.buildAllFilesInFolder = function (folderPath, environment, projectid, secretkey) {
        return __awaiter(this, void 0, void 0, function () {
            var files, error_1, files, _i, files_1, file, filePath, stats, filename, err_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, readdir(path_1.default.join(process.cwd(), '/.apilib/build/'))];
                    case 1:
                        files = _a.sent();
                        files.forEach(function (file) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, fs_1.default.unlinkSync(path_1.default.join(process.cwd(), "/.apilib/build/".concat(file)))];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); });
                        return [3 /*break*/, 3];
                    case 2:
                        error_1 = _a.sent();
                        console.error('Error clearing build folder:', error_1);
                        return [3 /*break*/, 3];
                    case 3:
                        _a.trys.push([3, 12, , 13]);
                        return [4 /*yield*/, readdir(folderPath)];
                    case 4:
                        files = _a.sent();
                        _i = 0, files_1 = files;
                        _a.label = 5;
                    case 5:
                        if (!(_i < files_1.length)) return [3 /*break*/, 11];
                        file = files_1[_i];
                        filePath = path_1.default.join(folderPath, file);
                        return [4 /*yield*/, stat(filePath)];
                    case 6:
                        stats = _a.sent();
                        if (!stats.isDirectory()) return [3 /*break*/, 8];
                        // Recursively process subfolders
                        return [4 /*yield*/, this.buildAllFilesInFolder(filePath, environment, projectid, secretkey)];
                    case 7:
                        // Recursively process subfolders
                        _a.sent();
                        return [3 /*break*/, 10];
                    case 8:
                        filename = path_1.default.basename(filePath);
                        return [4 /*yield*/, this.buildFile(filePath, filename, environment, projectid, secretkey)];
                    case 9:
                        _a.sent();
                        _a.label = 10;
                    case 10:
                        _i++;
                        return [3 /*break*/, 5];
                    case 11: return [3 /*break*/, 13];
                    case 12:
                        err_1 = _a.sent();
                        console.error('Error reading folder:', err_1);
                        return [3 /*break*/, 13];
                    case 13: return [2 /*return*/];
                }
            });
        });
    };
    return BuildService;
}());
// Export singleton instance of BuildService
exports.default = BuildService.getInstance();
