"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
// A map to store regular expressions for built-in Node.js modules
var builtInModulesMap = new Map();
// Populating the map with built-in module names and their corresponding regex patterns
[
    'assert',
    'async_hooks',
    'buffer',
    'child_process',
    'cluster',
    'console',
    'constants',
    'crypto',
    'dgram',
    'diagnostics_channel',
    'dns',
    'domain',
    'events',
    'fs',
    'http',
    'http2',
    'https',
    'inspector',
    'module',
    'net',
    'os',
    'path',
    'perf_hooks',
    'process',
    'punycode',
    'querystring',
    'readline',
    'repl',
    'stream',
    'string_decoder',
    'timers',
    'tls',
    'trace_events',
    'tty',
    'url',
    'util',
    'v8',
    'vm',
    'wasi',
    'worker_threads',
    'zlib',
].forEach(function (moduleName) {
    var regex = new RegExp("(['\"]".concat(moduleName, "['\"]).*?"), 'g');
    var modulePath = "$1node:".concat(moduleName, "$1");
    builtInModulesMap.set(regex, modulePath);
});
var FileService = /** @class */ (function () {
    function FileService() {
    }
    // Singleton pattern to ensure only one instance of FileService
    FileService.getInstance = function () {
        if (!this._instance) {
            this._instance = new FileService();
        }
        return this._instance;
    };
    // Generates a configuration file with default content
    FileService.prototype.generateConfigFile = function (filePath) {
        return __awaiter(this, void 0, void 0, function () {
            var rootDir;
            return __generator(this, function (_a) {
                rootDir = filePath || process.cwd();
                // Checks if the configuration file already exists
                if (fs_1.default.existsSync(path_1.default.join(rootDir, 'apilib.config.json'))) {
                    return [2 /*return*/, [false, 'Configuration file already exists. Delete the existing one to generate a new file.']];
                }
                // Writes the default content to the configuration file
                fs_1.default.writeFileSync(path_1.default.join(rootDir, 'apilib.config.json'), JSON.stringify({ projectid: '<YOUR PROJECT ID>', secretkey: '<YOUR SECRET KEY>' }, null, 2));
                return [2 /*return*/, [true, 'Configuration file generated. Please fill in the projectid and secretkey.']];
            });
        });
    };
    // Retrieves the configuration info from the file
    FileService.prototype.getConfigInfo = function (filePath) {
        return __awaiter(this, void 0, void 0, function () {
            var rootDir, configFileContent, config;
            return __generator(this, function (_a) {
                rootDir = filePath || process.cwd();
                // Checks if the configuration file exists
                if (!fs_1.default.existsSync(path_1.default.join(rootDir, 'apilib.config.json'))) {
                    return [2 /*return*/, [false, 'Configuration file does not exist. Please generate one first.']];
                }
                configFileContent = fs_1.default.readFileSync(path_1.default.join(rootDir, 'apilib.config.json'), 'utf8');
                config = JSON.parse(configFileContent);
                return [2 /*return*/, [true, config]];
            });
        });
    };
    // Finds the operator folder in the given directory
    FileService.prototype.findOperatorFolder = function (filePath) {
        return __awaiter(this, void 0, void 0, function () {
            var rootDir, files, _i, files_1, file, filePath_1, stats, foundPath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        rootDir = filePath || process.cwd();
                        files = fs_1.default.readdirSync(rootDir);
                        _i = 0, files_1 = files;
                        _a.label = 1;
                    case 1:
                        if (!(_i < files_1.length)) return [3 /*break*/, 5];
                        file = files_1[_i];
                        filePath_1 = path_1.default.join(rootDir, file);
                        stats = fs_1.default.statSync(filePath_1);
                        if (!(stats.isDirectory() && !file.startsWith('.') && !['node_modules', '.apilib'].includes(file.toLowerCase()))) return [3 /*break*/, 4];
                        if (!['operator', 'operators', 'routes'].includes(file.toLowerCase())) return [3 /*break*/, 2];
                        return [2 /*return*/, path_1.default.relative(process.cwd(), filePath_1)];
                    case 2: return [4 /*yield*/, this.findOperatorFolder(filePath_1)];
                    case 3:
                        foundPath = _a.sent();
                        if (foundPath) {
                            return [2 /*return*/, foundPath];
                        }
                        _a.label = 4;
                    case 4:
                        _i++;
                        return [3 /*break*/, 1];
                    case 5: return [2 /*return*/, null];
                }
            });
        });
    };
    // Replaces content in a file based on a search pattern
    FileService.prototype.replaceContentInFile = function (filePath, searchPattern, replaceValue) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        fs_1.default.readFile(filePath, 'utf8', function (err, fileContent) {
                            if (err) {
                                reject(err);
                                return;
                            }
                            var updatedContent = fileContent.replace(searchPattern, replaceValue);
                            fs_1.default.writeFile(filePath, updatedContent, function (err) {
                                if (err) {
                                    reject(err);
                                    return;
                                }
                                resolve();
                            });
                        });
                    })];
            });
        });
    };
    return FileService;
}());
// Exporting the singleton instance of FileService
exports.default = FileService.getInstance();
