"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Request = /** @class */ (function () {
    function Request() {
    }
    Request.getInstance = function () {
        if (!this._instance) {
            this._instance = new Request();
        }
        return this._instance;
    };
    Object.defineProperty(Request.prototype, "body", {
        get: function () {
            //Contains key-value pairs of data submitted in the request body
            return this._body;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Request.prototype, "cookies", {
        get: function () {
            //When using cookie-parser middleware, this property is an object that contains cookies sent by the request.
            return "";
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Request.prototype, "signedCookies", {
        get: function () {
            //When using cookie-parser middleware, this property contains signed cookies sent by the request, unsigned and ready for use
            return "";
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Request.prototype, "fresh", {
        get: function () {
            //When the response is still “fresh” in the client’s cache true is returned, otherwise false is returned to indicate that the client cache is now stale and the full response should be sent.
            return this._fresh;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Request.prototype, "stale", {
        get: function () {
            //Indicates whether the request is “stale,” and is the opposite of req.fresh.
            return this._stale;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Request.prototype, "ip", {
        get: function () {
            //Contains the remote IP address of the request.
            return this._ip;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Request.prototype, "method", {
        get: function () {
            //Contains a string corresponding to the HTTP method of the request: GET, POST, PUT, and so on.
            return this._method;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Request.prototype, "protocol", {
        get: function () {
            //Contains the request protocol string: either http or (for TLS requests) https.
            return this._protocol;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Request.prototype, "host", {
        get: function () {
            //Contains the host derived from the Host HTTP header.
            return this._host;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Request.prototype, "hostname", {
        get: function () {
            //Contains the hostname derived from the Host HTTP header.
            return this._hostname;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Request.prototype, "originalUrl", {
        get: function () {
            //This property is much like req.url; however, it retains the original request URL
            return this._originalUrl;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Request.prototype, "baseUrl", {
        get: function () {
            //The URL path on which a router instance was mounted
            return this._baseUrl;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Request.prototype, "path", {
        get: function () {
            //Contains the path part of the request URL.
            return this._path;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Request.prototype, "params", {
        get: function () {
            //This property is an object containing properties mapped to the named route “parameters”
            return this._params;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Request.prototype, "query", {
        get: function () {
            //This property is an object containing a property for each query string parameter in the route
            return this._query;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Request.prototype, "secure", {
        get: function () {
            //A Boolean property that is true if a TLS connection is established
            return this._secure;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Request.prototype, "xhr", {
        get: function () {
            //A Boolean property that is true if the request’s X-Requested-With header field is “XMLHttpRequest”, indicating that the request was issued by a client library such as jQuery.
            return this._xhr;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Request.prototype, "auth", {
        get: function () {
            //Contains the username and password portion of the URL
            return this._auth;
        },
        enumerable: false,
        configurable: true
    });
    Request.prototype.generateAuthentication = function (payload) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        resolve(["", ""]);
                    })];
            });
        });
    };
    Request.prototype.accepts = function (types) { };
    Request.prototype.get = function (field) { };
    Request.prototype.is = function (type) { };
    return Request;
}());
exports.default = Request;
