export type ResponseSettings = {};
export type CookieOptions = {
    domain?: String;
    expires?: Date;
    httpOnly?: Boolean;
    maxAge?: Number;
    path?: String;
    secure?: Boolean;
    signed?: Boolean;
    sameSite?: Boolean | String;
};
declare class Response {
    private static _instance;
    static getInstance(): Response;
    json(data: any): void;
    jsonP(data: any): void;
    links(links: {
        [x: string]: string;
    }): void;
    redirect(url: String): void;
    render(view: String, locals: any): void;
    send(body: String | Boolean | Array<any> | Object): void;
    sendStatus(statusCode: Number): void;
    status(statusCode: Number): this;
    attachment(fileName: any): void;
    download(fileName: any): void;
    type(type: string): void;
    cookie(name: string, value: string | object, options: CookieOptions | undefined): void;
    clearCookie(name: string, options: CookieOptions): void;
    get(field: string): string | undefined;
    set(field: string | object, value: string | undefined): void;
}
export default Response;
