// Importing the necessary modules from the 'util' directory
import MongoClient from "./util/MongoClient";  // For MongoDB operations
import Request from "./util/Request";           // For handling HTTP requests
import Datastore from "./util/Datastore";       // For datastore interactions
import Response, { CookieOptions, ResponseSettings } from "./util/Response";  // For handling HTTP responses

// Exporting the imported modules so they can be used elsewhere in the application
export { MongoClient, Datastore, Request, Response };
// Exporting types for CookieOptions and ResponseSettings for type safety and IntelliSense in other parts of the application
export type { CookieOptions, ResponseSettings };
